using System;
using System.Runtime.InteropServices;

namespace CustomToolGenerator
{
	public abstract class CustomToolBase : IVsSingleFileGenerator
	{
		/// <summary>
		/// TODO: ??????? ?????????? ???????????????? ?????
		/// </summary>
		/// <returns>??????????, ???????? ".cs"</returns>
		abstract public string GetDefaultExtension();

		/// <summary>
		/// TODO: ???????? ???????? ??????? ??????????
		/// <param name="fileContent">?????????? ????????? ?????</param>
		/// <returns>?????????? ???????????????? ?????</returns>
		abstract protected string GenerateCode(string fileContent);

		/// <summary>
		/// ???????? "CustomToolNamespace" ????????? ?????
		/// </summary>
		protected string CustomToolNamespace
		{
			get{return customToolNamespace;}
		}

		/// <summary>
		/// ?????? ???? ? ????????? ?????
		/// </summary>
		protected string InputFilePath
		{
			get{return inputFilePath;}
		}

		/// <summary>
		/// IDE API: ???????? ?????? ?????????? ? IDE 
		/// </summary>
		/// <param name="complete">?????????? ?????????? ????? ??? %</param>
		/// <param name="total">????? ?????????? ????? ??? 100 ??? ?????????</param>
		protected void SetProgress(int complete, int total)
		{
			if (codeGeneratorProgress == null) return;

			codeGeneratorProgress.Progress(complete, total);
		}

		/// <summary>
		/// IDE API: ??????? ????????? ?? ?????? ? IDE
		/// </summary>
		/// <param name="isWarning">?????????????? ??? ??????</param>
		/// <param name="level">??????? ??????????????</param>
		/// <param name="error">????? ?????????</param>
		/// <param name="line">??????</param>
		/// <param name="column">??????? ? ??????</param>
		protected void ReportError(bool isWarning, int level,
			string error, int line, int column)
		{
			if (codeGeneratorProgress == null) return;

			codeGeneratorProgress.GeneratorError(
				isWarning, level, error, line, column);
		}
		
		private IVsGeneratorProgress codeGeneratorProgress;
		private string customToolNamespace;
		private string inputFilePath;

		/// <summary>
		/// ????? ????? ? ????????? ?? IDE
		/// </summary>
		public void Generate(
			string               wszInputFilePath,
			string               bstrInputFileContents,
			string               wszDefaultNamespace,
			out System.IntPtr    rgbOutputFileContents,
			out int              pcbOutput,
			IVsGeneratorProgress pGenerateProgress)
		{
			inputFilePath         = wszInputFilePath;
			customToolNamespace   = wszDefaultNamespace;
			codeGeneratorProgress = pGenerateProgress;

			string code = GenerateCode(bstrInputFileContents);
			
			if (code == null) 
				throw new NullReferenceException(
					"Generated code string is null.");

			byte[] bytes = System.Text.Encoding.ASCII.GetBytes(code);
			pcbOutput = bytes.Length;
			rgbOutputFileContents = Marshal.AllocCoTaskMem(pcbOutput);
			Marshal.Copy(bytes, 0, rgbOutputFileContents, pcbOutput);
		}
	}


	[ComImport, 
	Guid("3634494C-492F-4F91-8009-4541234E4E99"), 
	InterfaceTypeAttribute(ComInterfaceType.InterfaceIsIUnknown)]
	public interface IVsSingleFileGenerator 
	{
		/// <summary>
		/// ?????????? ???????????????? ?????
		/// </summary>
		/// <returns>??????????, ???????? .cs</returns>
		[return: MarshalAs(UnmanagedType.BStr)]
		string GetDefaultExtension();

		/// <summary>
		/// ????? ????? ? ????????? ?? IDE
		/// </summary>
		/// <param name="wszInputFilePath">??? ? ?????? ???? ? ????????? ?????</param>
		/// <param name="bstrInputFileContents">????? ????????? ?????</param>
		/// <param name="wszDefaultNamespace">CustomToolNamespace parameter</param>
		/// <param name="rgbOutputFileContents">??????????????? ??? ? ??????? ????</param>
		/// <param name="pcbOutput">?????? ???????????????? ????</param>
		/// <param name="pGenerateProgress">callback-?????? ??????????</param>
		void Generate(
			[MarshalAs(UnmanagedType.LPWStr)] string wszInputFilePath,
			[MarshalAs(UnmanagedType.BStr)]   string bstrInputFileContents,
			[MarshalAs(UnmanagedType.LPWStr)] string wszDefaultNamespace, 
			out IntPtr rgbOutputFileContents,
			[MarshalAs(UnmanagedType.U4)] out int    pcbOutput,
			IVsGeneratorProgress                     pGenerateProgress);
	}


	[ComImport, 
	Guid("BED89B98-6EC9-43CB-B0A8-41D6E2D6669D"), 
	InterfaceTypeAttribute(ComInterfaceType.InterfaceIsIUnknown)]
	public interface IVsGeneratorProgress 
	{
		/// <summary>
		/// IDE API: ??????? ????????? ?? ?????? ? IDE
		/// </summary>
		/// <param name="isWarning">?????????????? ??? ??????</param>
		/// <param name="dwLevel">??????? ??????????????</param>
		/// <param name="bstrError">????? ?????????</param>
		/// <param name="dwLine">??????</param>
		/// <param name="dwColumn">??????? ? ??????</param>
		void GeneratorError(                  bool   isWarning,
			[MarshalAs(UnmanagedType.U4)]   int    dwLevel,
			[MarshalAs(UnmanagedType.BStr)] string bstrError,
			[MarshalAs(UnmanagedType.U4)]   int    dwLine,
			[MarshalAs(UnmanagedType.U4)]   int    dwColumn);

		/// <summary>
		/// IDE API: ???????? ?????? ?????????? ? IDE 
		/// </summary>
		/// <param name="nComplete">?????????? ?????????? ????? ??? %</param>
		/// <param name="nTotal">????? ?????????? ????? ??? 100 ??? ?????????</param>
		void Progress(
			[MarshalAs(UnmanagedType.U4)] int nComplete, 
			[MarshalAs(UnmanagedType.U4)] int nTotal);
	}
}
